/*
  Lab Solutions for Lab 9 Task 3
  
  Created by Michael Bykov (michael.bykov@wsu.edu)
  
  Implementation of sorting a list of names from a file.
*/

#include "BST.h"
#include <fstream>

int main(void) {
  {
    // Printing of the example tree in task 2
    BST<int> tree;
    tree.insert(42);
    tree.insert(25);
    tree.insert(10);
    tree.insert(30);
    tree.insert(15);
    tree.insert(75);
    tree.insert(65);
    tree.insert(100);
    tree.insert(70);
    
    std::cout << "  In-order traversal: ";
    tree.inOrderTraversal();
    std::cout << std::endl;
    
    std::cout << " Pre-order traversal: ";
    tree.preOrderTraversal();
    std::cout << std::endl;
    
    std::cout << "Post-order traversal: ";
    tree.postOrderTraversal();
    std::cout << std::endl;
  }
  
  {
    // String sorting (Task 3)
    BST<std::string> nameBST;
    
    // Read all the names from the file
    std::ifstream file("names.txt");
    while (!file.eof()) {
      std::string last, first;
      file >> last >> first;
      if (last.size() == 0)
        break;
      last.erase(last.size() - 1);
      nameBST.insert(first + " " + last);
    }
    
    // Sort the names by traversing the tree in order
    std::vector<std::string> names;
    nameBST.sort(names);
    
    // Print the names in order
    std::cout << "Sorted names:" << std::endl;
    for (int i = 0; i < names.size(); i++) {
      std::cout << names[i] << std::endl;
    }
  }
}
